﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.UI.Xaml.Diagram;
using Syncfusion.UI.Xaml.Diagram.Stencil;
using System.Reflection;

namespace _123174
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            //Symbol Collection for Stencil
            SymbolCollection symbolcollection = new SymbolCollection();
            stencil.SymbolSource = symbolcollection;

            stencil.Constraints = stencil.Constraints & ~StencilConstraints.Filters;
            stencil.SelectedFilter = new SymbolFilterProvider() { SymbolFilter = Filter };

            //Creating the SymbolItem
            SymbolItem a = new SymbolItem();
            uTest test = new uTest("$", 50, 50);
            uTestTemplate uTestTemp = new uTestTemplate();
            var t = new FrameworkElementFactory(typeof(uTestTemplate));
            a.Symbol = test;
            a.SymbolTemplate = new DataTemplate { VisualTree = t };
            a.GroupName = "Image";
            symbolcollection.Add(a);

            //ItemAdded Event - Invoked when new Instance Added  to Diagram
            (Diagram.Info as IGraphInfo).ItemAdded += MainWindow_ItemAdded;

            //To known Type for DataContract Serializer
            Diagram.KnownTypes = GetKnownTypes;
        }

        //To known Type for DataContract Serializer
        private IEnumerable<Type> GetKnownTypes()
        {
            List<Type> known = new List<Type>()
            {
                typeof(uTest),

            };
            foreach (var item in known)
            {
                yield return item;
            }
        }

        //ItemAdded Event - Invoked when new Instance Added  to Diagram
        void MainWindow_ItemAdded(object sender, ItemAddedEventArgs args)
        {
            CustomNodeViewModel cnvm = args.Item as CustomNodeViewModel;

            //Logic for Stencil

            //Arugument ItemSource is to notify Cause of the Event Invoke
            if (args.ItemSource == ItemSource.Stencil)
            {
                //Hook Property Changed event to Know Content and ContentTemplate Assigned
                cnvm.PropertyChanged += cnvm_PropertyChanged;
            }

            //Logic for Duplicate Node
            if (args.ItemSource == ItemSource.UnKnown)
            {
                //To Set the Content and ContentTemplate of Duplicate Node

            }
        }

        //Property Changed Event of NodeViewModel
        void cnvm_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            //Logica for Serialization and Duplicate
            CustomNodeViewModel nvm = (sender as CustomNodeViewModel);
            if (e.PropertyName == "Content")
            {
                //To Store the Content to property of NodeViewModel
                nvm.ContentName = nvm.Content;
            }
            if (e.PropertyName == "ContentTemplate")
            {
                //To Store the Type of ContentTemplate of NodeViewModel
                nvm.ContentType = (nvm.ContentTemplate as DataTemplate).VisualTree.Type.ToString();
            }
        }

        //Filter for Stencil
        private bool Filter(SymbolFilterProvider sender, object symbol)
        {
            return true;
        }



              
    }

    //Symbol for Stencil
    public class SymbolItem : ISymbol
    {
        public SymbolItem()
        {

        }

        public object Symbol
        {
            get;
            set;
        }

        public object Key
        {
            get;
            set;
        }
        public DataTemplate SymbolTemplate
        {
            get;
            set;
        }

        public string GroupName { get; set; }


        public ISymbol Clone()
        {
            return new SymbolItem()
            {
                Symbol = this.Symbol,
                SymbolTemplate = this.SymbolTemplate,
                Key = this.Key
            };
        }

    }

    //Custom Class of NodeViewmodel
    public class CustomNodeViewModel : NodeViewModel
    {
        public CustomNodeViewModel()
        {
            
        }

        /// <summary>
        /// To Store the Content to property of NodeViewModel
        /// </summary>
        private object _mContentName;
        [DataMember]
        public object ContentName
        {
            get
            {
                return _mContentName;
            }
            set
            {
                if (_mContentName != value)
                {
                    _mContentName = value;
                    OnPropertyChanged("ContentName");
                }
            }
        }

        /// <summary>
        /// To Store the ContentTemplate Type of NodeViewModel
        /// </summary>
        private string _mContentType;
        [DataMember]
        public string ContentType
        {
            get
            {
                return _mContentType;
            }
            set
            {
                if (_mContentType != value)
                {
                    _mContentType = value;
                    OnPropertyChanged("ContentType");
                }
            }
        }
    }

    //Custom Collection of CustomNodeViewModel
    public class CustomCollection : ObservableCollection<CustomNodeViewModel>
    {
        
    }

    //Custom Collection of ISymbol
    public class SymbolCollection : ObservableCollection<ISymbol>
    {

    }
}
